<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/core/common/trickle_timer.hpp Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d0/d11/trickle__timer_8hpp_source.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">trickle_timer.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../d0/d11/trickle__timer_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> *  Copyright (c) 2016, The OpenThread Authors.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *  All rights reserved.</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *  Redistribution and use in source and binary forms, with or without</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *  modification, are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *  1. Redistributions of source code must retain the above copyright</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer.</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *  2. Redistributions in binary form must reproduce the above copyright</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer in the</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *     documentation and/or other materials provided with the distribution.</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *  3. Neither the name of the copyright holder nor the</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *     names of its contributors may be used to endorse or promote products</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *     derived from this software without specific prior written permission.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *  POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#ifndef TRICKLE_TIMER_HPP_</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#define TRICKLE_TIMER_HPP_</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../df/d05/timer_8hpp.html">common/timer.hpp</a>&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">namespace </span><a class="code" href="../../d9/d00/namespaceThread.html">Thread</a> {</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="../../dd/d68/classThread_1_1TrickleTimer.html">   55</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html">TrickleTimer</a></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;{</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83d">   62</a></span>&#160;    <span class="keyword">typedef</span> <span class="keyword">enum</span> <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83d">Mode</a></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    {</div><div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83dae9656eb9148d1ffcc52ba4ed9e6fe44d">   64</a></span>&#160;        <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83dae9656eb9148d1ffcc52ba4ed9e6fe44d">kModeNormal</a>     = 0,  </div><div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83da69bf85abca130364d46610764c21139d">   65</a></span>&#160;        <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83da69bf85abca130364d46610764c21139d">kModePlainTimer</a> = 1,  </div><div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83daff6ea04b8c8bf1a98b2c700a895a351f">   66</a></span>&#160;        <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83daff6ea04b8c8bf1a98b2c700a895a351f">kModeMPL</a>        = 2,  </div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    } <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83d">Mode</a>;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="../../dd/d68/classThread_1_1TrickleTimer.html#a074951e5dd7191e7ce01b86f9b342e4f">   77</a></span>&#160;    <span class="keyword">typedef</span> bool (*<a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a074951e5dd7191e7ce01b86f9b342e4f">Handler</a>)(<span class="keywordtype">void</span> *aContext);</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#adac31ca11321ee61a5dd087f5572e946">TrickleTimer</a>(<a class="code" href="../../df/d1f/classThread_1_1TimerScheduler.html">TimerScheduler</a> &amp;aScheduler,</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;#ifdef ENABLE_TRICKLE_TIMER_SUPPRESSION_SUPPORT</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;                 uint32_t aRedundancyConstant,</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;#endif</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;                 <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a074951e5dd7191e7ce01b86f9b342e4f">Handler</a> aTransmitHandler, <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a074951e5dd7191e7ce01b86f9b342e4f">Handler</a> aIntervalExpiredHandler, <span class="keywordtype">void</span> *aContext);</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a8cbc5f44044d4bf3e560714545300095">IsRunning</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#ac701207b53eda0706d3a9bd08cf6bd82">Start</a>(uint32_t aIntervalMin, uint32_t aIntervalMax, <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83d">Mode</a> aMode);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a7df8440dbaec9a62b5d97b9dc6b3ef6b">Stop</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="preprocessor">#ifdef ENABLE_TRICKLE_TIMER_SUPPRESSION_SUPPORT</span></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keywordtype">void</span> IndicateConsistent(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a5e84cb0ebecd16b9087d0b5409fe86a9">IndicateInconsistent</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <span class="keywordtype">bool</span> TransmitFired(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mTransmitHandler(mContext); }</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <span class="keywordtype">bool</span> IntervalExpiredFired(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mIntervalExpiredHandler ? mIntervalExpiredHandler(mContext) : true; }</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="keywordtype">void</span> StartNewInterval(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> HandleTimerFired(<span class="keywordtype">void</span> *aContext);</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <span class="keywordtype">void</span> HandleTimerFired(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">enum</span> Phase</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    {</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        kPhaseDormant    = 1,</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        kPhaseTransmit   = 2,</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        kPhaseInterval   = 3,</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    } Phase;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <a class="code" href="../../d1/d40/classThread_1_1Timer.html">Timer</a> mTimer;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="preprocessor">#ifdef ENABLE_TRICKLE_TIMER_SUPPRESSION_SUPPORT</span></div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <span class="comment">// Redundancy constant</span></div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    <span class="keyword">const</span> uint32_t k;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <span class="comment">// Minimum interval size</span></div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    uint32_t Imin;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <span class="comment">// Maximum interval size</span></div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    uint32_t Imax;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <span class="comment">// The mode of operation</span></div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83d">Mode</a> mMode;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <span class="comment">// The current interval size (in milliseconds)</span></div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    uint32_t I;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    <span class="comment">// The time (in milliseconds) into the interval at which we should transmit</span></div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    uint32_t t;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;<span class="preprocessor">#ifdef ENABLE_TRICKLE_TIMER_SUPPRESSION_SUPPORT</span></div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    <span class="comment">// A counter, keeping track of the number of &quot;consistent&quot; transmissions received</span></div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    uint32_t c;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    <span class="comment">// The current trickle phase for the timer</span></div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    Phase mPhase;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <span class="comment">// Callback variables</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a074951e5dd7191e7ce01b86f9b342e4f">Handler</a> mTransmitHandler;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <a class="code" href="../../dd/d68/classThread_1_1TrickleTimer.html#a074951e5dd7191e7ce01b86f9b342e4f">Handler</a> mIntervalExpiredHandler;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <span class="keywordtype">void</span> *mContext;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;};</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;}  <span class="comment">// namespace Thread</span></div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;<span class="preprocessor">#endif  // TRICKLE_TIMER_HPP_</span></div><div class="ttc" id="classThread_1_1TrickleTimer_html_ac701207b53eda0706d3a9bd08cf6bd82"><div class="ttname"><a href="../../dd/d68/classThread_1_1TrickleTimer.html#ac701207b53eda0706d3a9bd08cf6bd82">Thread::TrickleTimer::Start</a></div><div class="ttdeci">void Start(uint32_t aIntervalMin, uint32_t aIntervalMax, Mode aMode)</div><div class="ttdoc">This method start the trickle timer. </div><div class="ttdef"><b>Definition:</b> trickle_timer.cpp:64</div></div>
<div class="ttc" id="classThread_1_1TrickleTimer_html_a3dc647d1536426b8dc214c115ca0a83d"><div class="ttname"><a href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83d">Thread::TrickleTimer::Mode</a></div><div class="ttdeci">Mode</div><div class="ttdoc">Represents the modes of operation for the TrickleTimer. </div><div class="ttdef"><b>Definition:</b> trickle_timer.hpp:62</div></div>
<div class="ttc" id="classThread_1_1TrickleTimer_html_adac31ca11321ee61a5dd087f5572e946"><div class="ttname"><a href="../../dd/d68/classThread_1_1TrickleTimer.html#adac31ca11321ee61a5dd087f5572e946">Thread::TrickleTimer::TrickleTimer</a></div><div class="ttdeci">TrickleTimer(TimerScheduler &amp;aScheduler, Handler aTransmitHandler, Handler aIntervalExpiredHandler, void *aContext)</div><div class="ttdoc">This constructor creates a trickle timer instance. </div><div class="ttdef"><b>Definition:</b> trickle_timer.cpp:41</div></div>
<div class="ttc" id="classThread_1_1TrickleTimer_html_a3dc647d1536426b8dc214c115ca0a83da69bf85abca130364d46610764c21139d"><div class="ttname"><a href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83da69bf85abca130364d46610764c21139d">Thread::TrickleTimer::kModePlainTimer</a></div><div class="ttdoc">Runs a normal timer between Imin and Imax. </div><div class="ttdef"><b>Definition:</b> trickle_timer.hpp:65</div></div>
<div class="ttc" id="classThread_1_1TrickleTimer_html"><div class="ttname"><a href="../../dd/d68/classThread_1_1TrickleTimer.html">Thread::TrickleTimer</a></div><div class="ttdoc">This class implements a trickle timer. </div><div class="ttdef"><b>Definition:</b> trickle_timer.hpp:55</div></div>
<div class="ttc" id="classThread_1_1TrickleTimer_html_a5e84cb0ebecd16b9087d0b5409fe86a9"><div class="ttname"><a href="../../dd/d68/classThread_1_1TrickleTimer.html#a5e84cb0ebecd16b9087d0b5409fe86a9">Thread::TrickleTimer::IndicateInconsistent</a></div><div class="ttdeci">void IndicateInconsistent(void)</div><div class="ttdoc">This method indicates to the trickle timer an &amp;#39;inconsistent&amp;#39; state. </div><div class="ttdef"><b>Definition:</b> trickle_timer.cpp:101</div></div>
<div class="ttc" id="classThread_1_1Timer_html"><div class="ttname"><a href="../../d1/d40/classThread_1_1Timer.html">Thread::Timer</a></div><div class="ttdoc">This class implements a timer. </div><div class="ttdef"><b>Definition:</b> timer.hpp:138</div></div>
<div class="ttc" id="classThread_1_1TimerScheduler_html"><div class="ttname"><a href="../../df/d1f/classThread_1_1TimerScheduler.html">Thread::TimerScheduler</a></div><div class="ttdoc">This class implements the timer scheduler. </div><div class="ttdef"><b>Definition:</b> timer.hpp:64</div></div>
<div class="ttc" id="classThread_1_1TrickleTimer_html_a8cbc5f44044d4bf3e560714545300095"><div class="ttname"><a href="../../dd/d68/classThread_1_1TrickleTimer.html#a8cbc5f44044d4bf3e560714545300095">Thread::TrickleTimer::IsRunning</a></div><div class="ttdeci">bool IsRunning(void) const </div><div class="ttdoc">This method indicates whether or not the trickle timer instance is running. </div><div class="ttdef"><b>Definition:</b> trickle_timer.cpp:59</div></div>
<div class="ttc" id="classThread_1_1TrickleTimer_html_a3dc647d1536426b8dc214c115ca0a83dae9656eb9148d1ffcc52ba4ed9e6fe44d"><div class="ttname"><a href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83dae9656eb9148d1ffcc52ba4ed9e6fe44d">Thread::TrickleTimer::kModeNormal</a></div><div class="ttdoc">Runs the normal trickle logic. </div><div class="ttdef"><b>Definition:</b> trickle_timer.hpp:64</div></div>
<div class="ttc" id="classThread_1_1TrickleTimer_html_a3dc647d1536426b8dc214c115ca0a83daff6ea04b8c8bf1a98b2c700a895a351f"><div class="ttname"><a href="../../dd/d68/classThread_1_1TrickleTimer.html#a3dc647d1536426b8dc214c115ca0a83daff6ea04b8c8bf1a98b2c700a895a351f">Thread::TrickleTimer::kModeMPL</a></div><div class="ttdoc">Runs the trickle logic modified for MPL. </div><div class="ttdef"><b>Definition:</b> trickle_timer.hpp:66</div></div>
<div class="ttc" id="classThread_1_1TrickleTimer_html_a7df8440dbaec9a62b5d97b9dc6b3ef6b"><div class="ttname"><a href="../../dd/d68/classThread_1_1TrickleTimer.html#a7df8440dbaec9a62b5d97b9dc6b3ef6b">Thread::TrickleTimer::Stop</a></div><div class="ttdeci">void Stop(void)</div><div class="ttdoc">This method stops the trickle timer. </div><div class="ttdef"><b>Definition:</b> trickle_timer.cpp:87</div></div>
<div class="ttc" id="timer_8hpp_html"><div class="ttname"><a href="../../df/d05/timer_8hpp.html">timer.hpp</a></div><div class="ttdoc">This file includes definitions for the multiplexed timer service. </div></div>
<div class="ttc" id="namespaceThread_html"><div class="ttname"><a href="../../d9/d00/namespaceThread.html">Thread</a></div><div class="ttdef"><b>Definition:</b> cli.cpp:61</div></div>
<div class="ttc" id="classThread_1_1TrickleTimer_html_a074951e5dd7191e7ce01b86f9b342e4f"><div class="ttname"><a href="../../dd/d68/classThread_1_1TrickleTimer.html#a074951e5dd7191e7ce01b86f9b342e4f">Thread::TrickleTimer::Handler</a></div><div class="ttdeci">bool(* Handler)(void *aContext)</div><div class="ttdoc">This function pointer is called when the timer expires. </div><div class="ttdef"><b>Definition:</b> trickle_timer.hpp:77</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_aebb8dcc11953d78e620bbef0b9e2183.html">core</a></li><li class="navelem"><a class="el" href="../../dir_34b4cee2b5900b653deb3438fc906cf4.html">common</a></li><li class="navelem"><a class="el" href="../../d0/d11/trickle__timer_8hpp.html">trickle_timer.hpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:33 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
